package dev.shadowsoffire.apotheosis.adventure.commands;

import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.arguments.IntegerArgumentType;
import net.minecraft.commands.Commands;
import net.minecraft.commands.CommandSourceStack;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;

public class SocketCommand
{
    public static void register(final LiteralArgumentBuilder<CommandSourceStack> root) {
        root.then(((LiteralArgumentBuilder)Commands.m_82127_("set_sockets").requires(c -> c.m_6761_(2))).then(Commands.m_82129_("sockets", (ArgumentType)IntegerArgumentType.integer(0, 16)).executes(c -> {
            final Player p = (Player)((CommandSourceStack)c.getSource()).m_81375_();
            final ItemStack stack = p.m_21205_();
            final LootCategory cat = LootCategory.forItem(stack);
            if (cat.isNone()) {
                ((CommandSourceStack)c.getSource()).m_81352_((Component)Component.m_237113_("The target item cannot receive sockets!"));
                return 1;
            }
            final int sockets = IntegerArgumentType.getInteger(c, "sockets");
            SocketHelper.setSockets(stack, sockets);
            return 0;
        })));
    }
}
